#ifndef CHECKEDASSIGN_H_CONTEXTMENU_HEADER
#define CHECKEDASSIGN_H_CONTEXTMENU_HEADER
// Nathan E. Moore
// March 5, 2005

#include <loki/TypeTraits.h>

namespace utility
{
	// this is a copy of RabidCow's MaybeParam class from Popup2
	// most things however have been renamed.
	// useful for parsing bang arguments.
	template<typename T>
	class CheckedAssign
	{
	private:
		typedef typename Loki::TypeTraits<T>::ParameterType ParameterType;
		typedef typename Loki::TypeTraits<T>::ReferredType& ReturnType;
	public:
		CheckedAssign()
			:assigned_(false),
			value_()
		{}

		explicit CheckedAssign(ParameterType defvalue)
			:assigned_(false),
			value_(defvalue)
		{}
		
		CheckedAssign& operator=(ParameterType value)
		{
			return SetValue(value);
		}

		bool IsAssigned() const
		{
			return assigned_;
		}

		// we return by reference so this cannot be a const method
		ReturnType GetValue()
		{
			return value_;
		}

		CheckedAssign& SetValue(ParameterType value)
		{
			value_ = value;
			assigned_ = true;
			return *this;
		}

	private:
		bool assigned_;
		T value_;
	};	// end class CheckedAssign
}	// end namespace utility

#endif // CHECKEDASSIGN_H_CONTEXTMENU_HEADER
