#ifndef COMREFCOUNTED_H_CONTEXTMENU_HEADER
#define COMREFCOUNTED_H_CONTEXTMENU_HEADER
// Nathan E. Moore
// March 8, 2005

namespace com
{
	// This is a copy of the Loki class of the same name this
	// version checks for NULL before calling AddRef or Release
    template <class P>
    class COMRefCounted
    {
    public:
        COMRefCounted()
        {}
        
        template <class U>
        COMRefCounted(const COMRefCounted<U>&)
        {}
        
        static P Clone(const P& val)
        {
			if (val)
				val->AddRef();
            return val;
        }
        
        static bool Release(const P& val)
		{
			if (val)
				val->Release();
			return false;
		}
        
        enum { destructiveCopy = false };
        
        static void Swap(COMRefCounted&)
        {}
    };
}	// end namespace com

#endif // COMREFCOUNTED_H_CONTEXTMENU_HEADER
